;||||||||||||
;
;"Lightnings"
;
;By XoreX
;For Boolean.Name :)
;12.03.2014 
;v. 1
;||||||||||||

Type light
 Field mesh
 Field p
 Field s
 Field c
 Field v
 Field timer#
 Field upd
End Type

Dim L(50)
Dim Spark(50)

;~~~~~~~~~~~~~~~~~~~~~~~~~~
;Fundamental
;~~~~~~~~~~~~~~~~~~~~~~~~~~

Function CreateChild(x1,y1,z1,x2,y2,z2,scale,mesh)
 s = CreateSurface(mesh)
  t1 = AddTriangle(s,AddVertex(s,x1+scale,y1,z1),AddVertex(s,x1-scale,y1,z1),AddVertex(s,x2+scale,y2,z2))
  t2 = AddTriangle(s,AddVertex(s,x1-scale,y1,z1),AddVertex(s,x2-scale,y2,z2),AddVertex(s,x2+scale,y2,z2))
  t3 = AddTriangle(s,AddVertex(s,x1,y1,z1+scale),AddVertex(s,x1,y1,z1-scale),AddVertex(s,x2,y2,z2+scale)) 
  t4 = AddTriangle(s,AddVertex(s,x1,y1,z1-scale),AddVertex(s,x2,y2,z2-scale),AddVertex(s,x2,y2,z2+scale)) 

End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function GenerateChild(x,y,z,scale,childs,visota,mesh)

 x1 = x
 y1 = y
 z1 = z
 x2 = 0
 y2 = y1
 z2 = 0

 y_step = visota / childs

 For i = 0 To childs
  x2 = x1 + Rnd(3.000,-3.000)
  y2 = y2 + y_step
  z2 = z1 + Rnd(3.000,-3.000)
  
  CreateChild(x1,y1,z1,x2,y2,z2,scale,mesh)

  x1 = x2
  y1 = y2
  z1 = z2
 Next
End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function GenerateMesh(x,y,z,scale,childs,visota,mesh)

 x1 = x
 y1 = y
 z1 = z
 x2 = 0
 y2 = y1
 z2 = 0

 y_step = visota / childs

 For i = 0 To childs
  x2 = x1 + Rnd(3.000,-3.000)
  y2 = y2 + y_step
  z2 = z1 + Rnd(3.000,-3.000)
  
  CreateChild(x1,y1,z1,x2,y2,z2,scale,mesh)

  If i > 5
   If Rand(1,15) = 10
    c = Rand(1,i-3)  
    generatechild(x1,y1,z1,scale,c,-c * y_step,mesh)
   EndIf 
  EndIf

  x1 = x2
  y1 = y2
  z1 = z2
 Next
End Function 

;~~~~~~~~~~~~~~~~~~~~~~~~~~
;Secondary
;~~~~~~~~~~~~~~~~~~~~~~~~~~

Function CreateSpark(x,y,z,Pitch#,Yaw#,Roll#,num#,lgth# = 10,scale = .1, childs# = 10)
 w.light = New light
  Spark(num) = Handle(w)

  w\s = scale
  w\c = childs#
  w\v = lgth#

  w\p = CreatePivot()
   PositionEntity w\p,x,y,z

  w\mesh = CreateMesh(w\p)
  EntityFX w\mesh,17
  RotateEntity w\mesh,pitch#,yaw#,roll#

  GenerateMesh(x,y,z,scale,childs#,lgth#,w\mesh)
 
End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function CreateLightning(x,y,z,num,scale = 1,child = 30,visota = 200,upd = False,timer = 3,sound$ = 1)
 w.light = New light



 w\s = scale
 w\c = child
 w\v = visota

 w\p = CreatePivot()
  PositionEntity w\p,x,y,z
 w\mesh = CreateMesh(w\p)
 EntityFX w\mesh,17
 ;EntityAlpha w\mesh,.2
 ;EntityColor w\mesh,122,66,25
 w\upd = upd
 w\timer = timer

 GenerateMesh(x,y,z,scale,child,visota,w\mesh)
 
 L(num) = Handle(w)

End Function 

;~~~~~~~~~~~~~~~~~~~~~~~~~~
;Manipulation
;~~~~~~~~~~~~~~~~~~~~~~~~~~

Global snd12345 
Function LightSound(sound$)
 snd12345 = Load3DSound(sound$)
End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function EmitSndFromL(num,min = 20000,max = 30000,random = True)
 w.light = Object.light(L(num))
 If random = True Then SoundPitch snd12345,Rand(min,max)
 EmitSound(snd12345,w\p)
End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function CopyLight(num1#,num2#)
 LightNotExist(num1#)
 
End Function
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function HideLight(num)
 w.light = Object.light(L(num))
  EntityAlpha w\mesh,0
End Function
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function LightNotExist(num)
 If l(num) = 0 Then RuntimeError "Lightning does not exist"
End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function DestroyLight(num)
 LightNotExist(num)

 w.light = Object.light(L(num))
  FreeEntity w\mesh
  w\mesh = CreateMesh(w\p)
  EntityFX w\mesh,17
End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function DeleteCell(num)
 If Not l(num) = 0
  w.light = Object.light(L(num))
   FreeEntity w\mesh
   FreeEntity w\p
   Delete w
   l(num) = 0
 EndIf
End Function 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
Function RegenLight(num,emit = False)

 LightNotExist(num)

 DestroyLight(num)

 w.light = Object.light(L(num))
   
 GenerateMesh(EntityX(w\p),EntityY(w\p),EntityZ(w\p),w\s,w\c,w\v,w\mesh)

 If emit = True 
  EmitSound(snd12345,w\p)
 EndIf 
 
End Function 

;~~~~~~~~~~~~~~~~~~~~~~~~~~
;Other
;~~~~~~~~~~~~~~~~~~~~~~~~~~



